package jp.deadend.noname.mt

import android.content.Context
import android.util.AttributeSet
import android.view.KeyEvent
import android.widget.LinearLayout

class LinearLayoutKeyDispatcher : LinearLayout {
    private var mCallback: Callback? = null

    interface Callback { fun commandShortcut(key: Int): Boolean }

    constructor(context: Context) : super(context)
    constructor(context: Context, attrs: AttributeSet) : super(context, attrs)

    fun setCallback(c: Callback) {
        mCallback = c
    }

    override fun dispatchKeyEventPreIme(event: KeyEvent): Boolean {
        if (event.action == KeyEvent.ACTION_DOWN) {
            mCallback?.let {
                if (it.commandShortcut(SetKeyDialogFragment.encodeKey(event))) { return true }
            }
        }

        return super.dispatchKeyEventPreIme(event)
    }
}
